/**
 * Represents a set from which samples should be gathered
 */
rectest.set.Set = Interface( 'Set',
{
    /**
     * Create a new set from a base set and the given options
     *
     * It should be noted that the sample size is required because certain
     * algorithms need to understand the data in order to provide a truely
     * random set across all samples.
     *
     * @param {Array.<string>} base_set    base set
     * @param {number}         sample_size number of samples to be returned
     */
    __construct: [ 'base_set', 'sample_size' ],


    /**
     * Retrieve the next element in the set
     *
     * @return {string} next element in set
     */
    'public getNextElement': []
} );
